
#ifndef Term_h
#define Term_h

#include <wchar.h>

#ifndef MB_LEN_MAX
#define MB_LEN_MAX 6 /* for UTF-8 */
#endif
#define MAX_CCHARS 5

class Term {
 public:
  Term (int _xsize, int _ysize);
  virtual ~Term () {};
  
  void out (char *s, int n);
  
  void redraw ();
  
 protected:
  
  virtual void put_char (int x, int y, wchar_t wc,
			 int fg, int bg, int ul) = 0;

  void resize (int _sizex, int _sizey);
  
  int xsize, ysize;
  
 private:
  
  void scrolldown ();
  void scrollup ();
  
  bool is_clear (int);
  void cursor_down ();
  
  void clear_line (int y);
  void clear_left ();
  void clear_right ();
  inline void clear_one (int i);
  
  void show_cursor (bool show);

  void save ();
  void unsave ();
  
  int xpos, ypos;
  int scrollA, scrollB;
  int def_fg, def_bg;
  int fg, bg, ul;
  int rev;
  int state;
  int cur_visible;
  int xp, yp;
  int arg[2];
  
  bool saved;
  int saved_xpos, saved_ypos;
  // saved_ attributes
  
  mbstate_t ps;
  
  wchar_t* screen; /* character in cell, or 0 */
  int *screenfg, *screenbg, *screenul; /* colours and underline of cells */
  
  int acs;
};

#endif
